/*
 * Kerneos
 * Copyright (C) 2012 Bull S.A.S.
 * Contact: jasmine AT ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * $Id$
 */

/**
 * @author Loic Albertin
 */
package org.ow2.kerneos.examples.extensions.command {
import com.adobe.cairngorm.commands.ICommand;
import com.adobe.cairngorm.control.CairngormEvent;

import org.ow2.kerneos.examples.extensions.MyModule;
import org.ow2.kerneos.examples.extensions.common.event.InsuranceEvent;

public class InsuranceCommand implements ICommand {
    public function InsuranceCommand() {
    }

    public function execute(event:CairngormEvent):void {
        if (event is InsuranceEvent) {
            var insuranceEvent:InsuranceEvent = event as InsuranceEvent;
            if (insuranceEvent.type == InsuranceEvent.INSURANCE_INIT) {
                MyModule.getInstance().getModel().moduleState = "init";
            } else if (insuranceEvent.type == InsuranceEvent.INSURANCE_APPROVED) {
                MyModule.getInstance().getModel().moduleState = "approved";
                MyModule.getInstance().getModel().payment = insuranceEvent.payment;
            } else if (insuranceEvent.type == InsuranceEvent.INSURANCE_REJECTED) {
                MyModule.getInstance().getModel().moduleState = "rejected";
                MyModule.getInstance().getModel().rejectedReason = insuranceEvent.reason;
            }
        }
    }
}
}
